<?php
/*
Plugin Name: Qikmo Mobile Website Redirection
Description: Automatically redirects mobile users to mobile version of the site.
Author: Constantin V. Bosneaga
Author URI: http://a32.me/
Email: constantin@bosneaga.com
Version: 1.0
*/

include "form.php";

class Qikmo_Plugin {

    /**
     * Init plugin
     */
    function init() {
        add_action('admin_menu', array($this, 'wp_admin_menu'));
        add_action('template_redirect', array($this, 'redirect'), 1);
    }

    function redirect() {
        $data = get_option('qikmo_options');
        if (empty($data['domain'])) return;

        $mobileDomain = $data['domain'];
        $no_redirect = @$_REQUEST['no_redirect'];
        if ($no_redirect != "true") {
            $agent = @$_SERVER['HTTP_USER_AGENT'];
            @ini_set('default_socket_timeout', 1);

            /* check if we should redirect*/
            $handle = @fopen("http://mobile.previewmymobile.com/api/public/detect?ua=" . urlencode($agent), "r");
            @stream_set_timeout($handle, 1);
            $result = @fread($handle, 1);
            @fclose($handle);

            if ($result == "y") {
                $currenturl = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
                $mobileUrl = $mobileDomain . "?url=" . urlencode($currenturl);
                $mobileUrl = $mobileUrl . "&dm_redirected=true";
                header("Location: " . $mobileUrl);
                exit;
            }
        }
    }

    /**
     * Registers admin menu for setup
     */
    function wp_admin_menu() {
        add_submenu_page('options-general.php', 'Qikmo Setup', 'Qikmo Setup', 'manage_options', 'qikmo_setup', array($this, 'wp_setup'));
    }

    /**
     * ADMIN Setup page
     *
     */
    function wp_setup() {
        // Save values on POST
        if (isset($_POST['version'])) {
            $data = $_POST;
            update_option('qikmo_options', $data);
        }

        // get current options
        $data = get_option('qikmo_options');
        if (!$data) {
            $data = array();
            update_option('qikmo_options', $data);
        }

        // Create form and values
        $form = new A32_Form();
        require_once "setup.php";
        $form->end();
        $form->set_array($data);

        // Display form
        $form->render();
    }

}

$plugin_instance = new Qikmo_Plugin();
$plugin_instance->init();

